#include "common.h"
#include "image.h"
#include "filtering.h"
#include "spectrum.h"

/* Questo 1: Este programa cria duas imagens de cosseno e verifica
   que o espectro da soma delas  a soma dos espectros. 

   A questo vale 2,5 pontos distribudos da seguinte forma:

   (0,5) Como a FFT2D s funciona para imagens cujas dimenses so
   potncias de 2, crie uma funo AddZeros em image.c para ser
   chamada antes de FFT2D.

   (0,5) Como a InvFFT2D gerar uma imagem com zeros  direita e
   abaixo, no caso de voc ter usado AddZeros antes, ento crie uma
   funo RemZeros em image.c para ser chamada aps InvFFT2D.

   (0,5) Use a seqncia de comandos abaixo para visualizar o espectro
   de vrios filtros espaciais e verificar se suas funes acima esto
   corretas. Escreva suas concluses sobre o experimento. A seqncia
   abaixo  aplicada para o filtro Gaussiano 3x3.
   
   img1 = CreateIntArray("3,3,1,2,1,2,4,2,1,2,1");
   img2 = AddZeros(img1,253,253);
   DestroyImage(&img1);
   spc2 = FFT2D(img2);
   mag2 = ViewMagnitude(spc2);
   WriteImage(mag2,"spcmasc.pgm");
   DestroyImage(&mag2);
   DestroyImage(&img2);
   img2 = InvFFT2D(spc2);
   img1 = RemZeros(img2,253,253);
   WriteImage(img1,"masc.pgm");
   DestroyImage(&img1);
   DestroyImage(&img2);

   (1,0) Modifique os parmetros de freqncia, fase, e resoluo, e
   comente os resultados. Lembre-se de usar as funes acima no caso
   de imagens com resoluo diferente de potncia de 2. Verifique a
   relao entre o perodo do cosseno no domnio espacial (distncia
   em pixels) e a freqncia do cosseno medida no espectro. Verifique
   tambm se o espectro de fase est correto. Escreva suas concluses
   sobre os experimentos.

*/

int main()
{
  Image *img1, *img2, *img3;
  Image *mag1, *mag2, *mag3;
  Spectrum *spc1, *spc2, *spc3;


  img1 = CreateCos(256,256,32,0,0,0); /* Cria imagem do cosseno com
					 256x256, wx = 32, wy = 0,
					 phx=phy=0. */

  img2 = CreateCos(256,256,0,16,0,0); /* Cria imagem do cosseno com
					 256x256, wx = 0, wy = 16,
					 phx=phy=0. */


  img3 = Sum(img1,img2); /* Soma as imagens */

  /* O espectro da soma  a soma dos espectros */

  spc1 = FFT2D(img1);  /* Calcula FFT */
  spc2 = FFT2D(img2);
  spc3 = FFT2D(img3);
  
  mag1 = ViewMagnitude(spc1);  /* Calcula Magnitude para visualizao */
  mag2 = ViewMagnitude(spc2);
  mag3 = ViewMagnitude(spc3);
  
  /* Grava imagens para serem visualizadas com gimp ou xv */
  WriteImage(mag1,"mag1.pgm");                              
  WriteImage(mag2,"mag2.pgm");
  WriteImage(mag3,"mag3.pgm");

  DestroyImage(&img1);
  DestroyImage(&img2);
  DestroyImage(&img3);
  DestroyImage(&mag1);
  DestroyImage(&mag2);
  DestroyImage(&mag3);
  DestroySpectrum(&spc1);
  DestroySpectrum(&spc2);
  DestroySpectrum(&spc3);


  return(0);
}
