#include "common.h"
#include "image.h"
#include "filtering.h"
#include "spectrum.h"

/* Questo 2: Este programa verifica o teorema da convoluo no espao.

   A questo vale 2,5 pontos distribudos da seguinte forma:

   (0,5) A convoluo discreta requer a reflexo de uma das
   imagens. Crie uma funo ReflectImage em filtering.c para fazer
   isto. Considere a origem no centro da imagem, visto que a imagem a
   ser refletida ser a da mscara.

   (1,0) Crie uma funo FilterInSpace em filtering.c para calcular a
   convoluo no espao.

   (1,0) Crie uma funo FilterInFreq em filtering.c para
   calcular a filtragem na freqncia.

   Modifique as imagens e mscaras abaixo gerando alguns resultados
   deste experimento. Comente todos os resultados.
   
*/

int main()
{
  Image *img1, *img2, *img3;
  Spectrum *spc1, *spc2, *spc3;


  img1 = CreateSquare(25,25,75,75,256,256,255); /* Cria imagem de
						   256x256 pixels de
						   um quadrado branco
						   (255) de 50x50
						   pixels na posio
						   (25,25) at a
						   posio (75,75). */
  img2 = CreateIntArray("3,3,-1,-2,-1,0,0,0,1,2,1"); /* Cria mscara
                                                        de Sobel_y */

  img3 = FilterInSpace(img1,img2); /* Calcula filtragem por convoluo. */
  WriteImage(img3,"space.pgm");
  DestroyImage(&img3);
  img3 = AddZeros(img2,253,253); /* Coloca mscara com 256x256 pixels */

  spc1 = FFT2D(img1);
  spc3 = FFT2D(img3);
  spc2 = FilterInFreq(spc1,spc3); /* calcula filtragem na freqncia */
  DestroyImage(&img3);
  img3 = InvFFT2D(spc2);
  WriteImage(img3,"freq.pgm");
						   

  DestroyImage(&img1);
  DestroyImage(&img2);
  DestroyImage(&img3);
  DestroySpectrum(&spc1);
  DestroySpectrum(&spc2);
  DestroySpectrum(&spc3);


  return(0);
}
