#include "common.h"
#include "image.h"
#include "filtering.h"
#include "spectrum.h"

/* Questo 3: Neste programa voc deve demonstrar a filtragem de
imagens na freqncia usando filtros de Butterworth passa-baixas,
passa-altas, passa-faixa, e rejeita-faixa. Use inicialmente a imagem
lena.pgm para testar os filtros, e depois projete um filtro
passa-faixa para filtrar as imagens de impresses digitais. A idia 
filtrar o padro circular que aparece na freqncia. Lembre-se que as
impresses no tm resoluo potncia de 2 e que ambos espectros devem
ter a mesma resoluo para efetuar a filtragem.

   A questo vale 4,0 pontos distribudos da seguinte forma:

   (0,5) Crie uma funo LowPassFilter em spectrum.c para gerar o
   espectro do filtro de Butterworth passa-baixas.

   (0,5) Crie uma funo HighPassFilter em spectrum.c para gerar o
   espectro do filtro de Butterworth passa-altas.

   (1,0) Crie uma funo BandPassFilter em spectrum.c para gerar o
   espectro do filtro de Butterworth passa-faixa.

   (1,0) Crie uma funo BandRejectFilter em spectrum.c para gerar o
   espectro do filtro de Butterworth rejeita-faixa.

   (1,0) Projete e teste o filtro para as imagens de impresses
   digitais com diferentes parmetros.

Ilustre todos os resultados desta questo com imagens e faa comentrios.

*/

int main()
{
  Image *img1,*img2;
  Spectrum *spc1,*spc2,*spc3;

  img1 = ReadImage("images/lena.pgm");
  spc1 = FFT2D(img1);
  spc2 = LowPassFilter(256,256,64,1); /* Cria filtro passa-baixas de
                                         Butterworth */
  spc3 = FilterInFreq(spc1,spc2);
  img2 = InvFFT2D(spc3);
  WriteImage(img2,"filt.pgm");
  
  DestroyImage(&img1);
  DestroyImage(&img2);
  DestroySpectrum(&spc1);
  DestroySpectrum(&spc2);
  DestroySpectrum(&spc3);


  return(0);
}
