#include "gift.h"

int main(int argc, char **argv)
{
  timer tic,toc;
  FILE *ftime=fopen("time.txt","w");
  AdjRel *A=NULL;
  Image *img;
  Image *aux1,*aux2;

  /* The following block must the remarked when using non-linux machines 

  void *trash = malloc(1);                 
  struct mallinfo info;   
  int MemDinInicial, MemDinFinal;
  free(trash); 
  info = mallinfo();
  MemDinInicial = info.uordblks;
  */
  
  /* Fechamento por reconstrucao */

  img      = ReadImage("../data/vessels.pgm");  
  A        = Circular(5.0);
  gettimeofday(&tic,NULL);  
  aux1     = CloseRec(img,A);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"CloseRec in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);
  aux2     = Diff(aux1,img);
  WriteImage(aux2,"questao1_a.pgm");
  DestroyImage(&aux1);
  DestroyImage(&aux2);
  
  /* Fechamento de bacias */

  gettimeofday(&tic,NULL);  
  aux1     = CloseBasins(img);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"CloseBasins in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);
  aux2     = Diff(aux1,img);
  WriteImage(aux2,"questao1_b.pgm");
  DestroyImage(&aux1);
  DestroyImage(&aux2);

  /* Abertura por reconstrucao */ 

  DestroyImage(&img);
  img      = ReadImage("../data/bloodcells.pgm");  
  gettimeofday(&tic,NULL);  
  aux1     = OpenRec(img,A);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"OpenRec in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);

  WriteImage(aux1,"questao1_c.pgm");
  DestroyImage(&aux1);

  /* Abertura de domos */

  DestroyImage(&img);
  img      = ReadImage("../data/believe.pgm");  
  gettimeofday(&tic,NULL);  
  aux1     = OpenDomes(img);
  gettimeofday(&toc,NULL);
  fprintf(ftime,"OpenDomes in %f milliseconds\n",(toc.tv_sec-tic.tv_sec)*1000.0 + (toc.tv_usec-tic.tv_usec)*0.001);

  WriteImage(aux1,"questao1_d.pgm");
  DestroyImage(&aux1);

  DestroyImage(&img);
  DestroyAdjRel(&A);

  /* The following block must the remarked when using non-linux machines 

  info = mallinfo();
  MemDinFinal = info.uordblks;
  if (MemDinInicial!=MemDinFinal)
    printf("\n\nDinamic memory was not completely deallocated (%d, %d)\n",
	   MemDinInicial,MemDinFinal);   
  */

  fclose(ftime);

  return(0);
}
