#include "morphology.h" 

Image *Dilate(Image *img, AdjRel *A)
{
  Image *dil=NULL;
  int p,q,max,i;
  Pixel u,v;

  dil = CreateImage(img->ncols,img->nrows);

  for (u.y=0; u.y < img->nrows; u.y++)
    for (u.x=0; u.x < img->ncols; u.x++){
      p   = u.x + img->tbrow[u.y];
      max = img->val[p];
      for (i=0; i < A->n; i++){
	v.x = u.x + A->dx[i];
	v.y = u.y + A->dy[i];
	if (ValidPixel(img,v.x,v.y)){
	  q = v.x + img->tbrow[v.y];
	  if (img->val[q] > max)
	    max = img->val[q];
	}
      }
      dil->val[p]=max;
    }
  return(dil);
}

Image *Erode(Image *img, AdjRel *A)
{
  Image *ero=NULL;
  int p,q,min,i;
  Pixel u,v;

  ero = CreateImage(img->ncols,img->nrows);

  for (u.y=0; u.y < img->nrows; u.y++)
    for (u.x=0; u.x < img->ncols; u.x++){
      p   = u.x + img->tbrow[u.y];
      min = img->val[p];
      for (i=0; i < A->n; i++){
	v.x = u.x + A->dx[i];
	v.y = u.y + A->dy[i];
	if (ValidPixel(img,v.x,v.y)){
	  q = v.x + img->tbrow[v.y];
	  if (img->val[q] < min)
	    min = img->val[q];
	}
      }
      ero->val[p]=min;
    }
  return(ero);
}

Image *Open(Image *img, AdjRel *A)
{
  Image *open=NULL,*ero=NULL;

  ero  = Erode(img,A);
  open = Dilate(ero,A);
  DestroyImage(&ero);

  return(open);
}

Image *Close(Image *img, AdjRel *A)
{
  Image *close=NULL,*dil=NULL;

  dil   = Dilate(img,A);
  close = Erode(dil,A);
  DestroyImage(&dil);

  return(close);
}

Image *MorphGrad(Image *img, AdjRel *A)
{
  Image *dil=NULL,*ero=NULL,*grad=NULL;

  dil  = Dilate(img,A);
  ero  = Erode(img,A);
  grad = Diff(dil,ero);

  DestroyImage(&dil);
  DestroyImage(&ero);

  return(grad);
}

/*--------------------------------------------------------------------*/
/* Funcoes da questao 1 (2,0): Use IFTFIFO para implementar os filtros
   por reconstrucao abaixo em alto nivel. Use CopyImage em image.c
   para copiar o conteudo desejado da imagem anotada. Esta observacao
   vale para todas as funcoes do projeto que criam internamente
   imagens anotadas. */

Image *CloseRec(Image *img, AdjRel *A)
{
  Image  *crec=NULL;

  return(crec);
}

Image *OpenRec(Image *img, AdjRel *A)
{
  Image  *orec=NULL;

  return(orec);
}

Image *CloseBasins(Image *img)
{
  Image  *cbas=NULL;

  return(cbas);
}

Image *OpenDomes(Image *img)
{
  Image  *odom=NULL;

  return(odom);
}

/*--------------------------------------------------------------------*/
/* Funcoes da questao 2 (2,0): Copie IFTFIFO e modifique-a para que os
filtros por reconstrucao abaixo so calculem a informacao necessaria e
o mais rapido possivel. Nao use imagem anotada e nenhuma funcao de
genift.c. Use adjacencia-4 em todas as funcoes abaixo. */

void SupRec(Image *mask, Image *marker)
{

}

void LocalSupRec(Image *mask, Image *marker)
{

}
